#include <stdio.h>

#include "wifi.h"
#include "camera.h"
#include "webserver.h"

#include "nvs_flash.h"

void app_main() {
    //Initialize NVS
    esp_err_t ret = nvs_flash_init();
    if (ret == ESP_ERR_NVS_NO_FREE_PAGES || ret == ESP_ERR_NVS_NEW_VERSION_FOUND) {
      ESP_ERROR_CHECK(nvs_flash_erase());
      ret = nvs_flash_init();
    }
    ESP_ERROR_CHECK(ret);

    ESP_ERROR_CHECK(wifi_init());

    ESP_ERROR_CHECK(setup_camera());

    start_camera_server();
}

