#ifndef PROTOCOL_H
#define PROTOCOL_H

#include <stddef.h>
#include <stdint.h>

#define LEN_DATA 1024

#define DATA ((uint32_t) 0)
#define NEW_FILE ((uint32_t) 1)
#define FILE_DONE ((uint32_t) 2)
#define CLOSE_CONNECTION ((uint32_t) 3)

/* typedef struct { */
/*   uint32_t type; */
/*   uint32_t data; */
/* } header_t; */

typedef struct {
  uint32_t type;
  uint32_t data;
} ctrl_msg_t;


void send_ctrl(int fd, uint32_t type, uint32_t data);
void send_data(int fd, unsigned char *buffer, size_t len);

void receive_data(int fd, unsigned char *buffer, size_t len);
uint32_t receive_ctrl(int fd, ctrl_msg_t *msg);

uint32_t expect(int fd, uint32_t type);

void fatal(const char *error, ...);

/*
unsigned char *alloc_buffer(size_t len_buffer);
*/
#endif
