#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <unistd.h>
#include <sys/param.h>

#include "protocol.h"

#define MAX_LENGTH_FILENAME 100

/* *****************************************************************************
 * deal with Ctrl^C
 * ****************************************************************************/

#define MAX_LENGTH_FILENAME 100

void write_binary_buffer(unsigned char* buffer, size_t len_buffer, char* filename) {
    FILE* file = fopen(filename, "wb"); // Open the file in binary write mode
    if (file == NULL) {
        perror("Error opening file");
        return;
    }
    size_t bytes_written = fwrite(buffer, sizeof(unsigned char), len_buffer, file);
    if (bytes_written != len_buffer) {
      fatal("Error writing to file");
    }
    fclose(file);
}



int write_file(int client_fd, char *filename) {
  uint32_t len_buffer = expect(client_fd, NEW_FILE);
  printf("got a NEW_FILE with length: %d\n", len_buffer);
  unsigned char *buffer = (unsigned char *) malloc(len_buffer);

  int file_done = 0;
  receive_data(client_fd, buffer, len_buffer);
  
  uint32_t time = expect(client_fd, FILE_DONE);

  int64_t times[6];
  receive_data(client_fd, (unsigned char *) times, sizeof(times));

  for (int i = 0; i < 5; i++) {
    printf("Time %d: %ld us\n", i, times[i]);
  }
  printf("Time %d: %ld ms\n", 5, times[5]);
  
  write_binary_buffer(buffer, len_buffer, filename);

  free(buffer);

  puts("done");
  
  return 0;
}

int main() {

  /* signal(SIGINT, sigint_handler); */
  
  // Create the server socket
  int server_fd = socket(AF_INET, SOCK_STREAM, 0);
  if (server_fd == -1) {
    fprintf(stderr, "Error: Failed to create server socket\n");
    return 1;
  }

  // Bind the socket to a port
  struct sockaddr_in addr = {0};
  addr.sin_family = AF_INET;
  addr.sin_port = htons(12345);
  addr.sin_addr.s_addr = INADDR_ANY;
  if (bind(server_fd, (struct sockaddr *) &addr, sizeof(addr)) == -1) {
    fprintf(stderr, "Error: Failed to bind server socket\n");
    return 1;
  }

  // Listen for incoming connections
  if (listen(server_fd, 1) == -1) {
    fprintf(stderr, "Error: Failed to listen for connections\n");
    return 1;
  }

  // Accept a client connection
  int client_fd = accept(server_fd, NULL, NULL);
  if (client_fd == -1) {
    fprintf(stderr, "Error: Failed to accept client connection\n");
    return 1;
  }


  for (int i = 0; i < 100; i++) {
    char filename[MAX_LENGTH_FILENAME];
    snprintf(filename, MAX_LENGTH_FILENAME, "output_%03d.jpg", i + 1);
    write_file(client_fd, filename);
  }

  printf("time: %d\n", expect(client_fd, CLOSE_CONNECTION));

  // Close the client and server sockets
  close(client_fd);
  close(server_fd);

  return 0;
}

