#ifndef MUX_H
#define MUX_H

#define STREAM_DURATION   10.0
#define STREAM_FRAME_RATE 25 /* 25 images/s */
#define STREAM_PIX_FMT    AV_PIX_FMT_YUV420P /* default pix_fmt */

#define SCALE_FLAGS SWS_BICUBIC

#include <libavutil/avassert.h>
#include <libavutil/channel_layout.h>
#include <libavutil/opt.h>
#include <libavutil/mathematics.h>
#include <libavutil/timestamp.h>
#include <libavcodec/avcodec.h>
#include <libavformat/avformat.h>
#include <libswscale/swscale.h>
#include <libswresample/swresample.h>


// a wrapper around a single output AVStream
typedef struct OutputStream {
  AVStream *st;
  AVCodecContext *enc;

  /* pts of the next frame that will be generated */
  int64_t next_pts;
  int samples_count;

  AVFrame *frame;
  AVFrame *tmp_frame;

  AVPacket *tmp_pkt;

  float t, tincr, tincr2;

  struct SwsContext *sws_ctx;
  struct SwrContext *swr_ctx;

  AVFrame *jpg_frame;
  volatile AVPacket *jpg_packet;
  AVCodecContext *jpg_codec_ctx;

  /* int num_frames; */
  /* char **frame_files; */

  /* unsigned char *buffer; */
  /* uint32_t len_buffer; */
  
} OutputStream;

extern OutputStream video_st;
extern AVFormatContext *oc;

int init_mux(const char *filename);
int deinit_mux();
int write_video_frame(AVFormatContext *oc, OutputStream *ost);

#endif
